package br.usp.ime.evolvinggraph;

import java.util.SortedSet;

public class Edge {
	Node u;
	Node v;
	SortedSet<Integer> schedule;
	int cost;
	
	public Edge(Node u, Node v, SortedSet<Integer> sched, int cost) {
		this.u = u;
		this.v = v;
		this.schedule = sched;
		this.cost = cost;
	}
	
	public Integer getNextDeparture(int time) {
		SortedSet<Integer> possibleDepartures = this.schedule.tailSet(time);
		if (possibleDepartures == null || possibleDepartures.isEmpty()) return null;
		return possibleDepartures.first();
	}

	public Node getU() {
		return u;
	}

	public void setU(Node u) {
		this.u = u;
	}

	public Node getV() {
		return v;
	}

	public void setV(Node v) {
		this.v = v;
	}

	public int getCost() {
		return cost;
	}

	public void setCost(int cost) {
		this.cost = cost;
	}

	public SortedSet<Integer> getSchedule() {
		return schedule;
	}
	
	
	
}
