package br.usp.ime.evolvinggraph;

import java.util.ArrayList;

public class Journey {
	ArrayList<Edge> edge;
	ArrayList<Integer> time;
	int size;
	
	public Journey() {
		edge = new ArrayList<Edge>();
		time = new ArrayList<Integer>();
		size = 0;
	}
	
	public Journey(Journey j) {
		edge = new ArrayList<Edge>(j.edge);
		time = new ArrayList<Integer>(j.time);
		size = j.size;
	}
	
	public Journey(Journey j, Edge e, int t){
		edge = new ArrayList<Edge>(j.edge);
		time = new ArrayList<Integer>(j.time);
		size = j.size;
		append(e, t);
	}

	public void append(Edge e, int t){
		edge.add(e);
		time.add(t);
		size++;
	}
	
	public String toString(){
		String str = "";
		for (int i = 0; i < size; i++){
			Edge e = edge.get(i);
			str += "("+e.u.id+"["+time.get(i)+"]"+e.v.id + ")";
		}
		return str;
	}

	public Integer getArrivalDate() {
		if (time.size() == 0) return null;
		return time.get(time.size()-1) + edge.get(edge.size()-1).getCost();
	}
	
	public Integer getTransitTime(){
		if (time.size() == 0) return null;
		return getArrivalDate() - time.get(0);
	}
	
	public Integer getSize(){
		return size;
	}
	
	public ArrayList<Edge> getEdges () {
		return edge;
	}
	
	public ArrayList<Integer> getTimes () {
		return time;
	}
	
	public double getCost(double timeCost, double edgeCost ){
		return timeCost*getArrivalDate() + edgeCost*size;
	}
}
